10/01/84 -------------------------------------------------------------

.PATCH27 for a current list of patches to MultiLink release 2.07:


       Patches for MultiLink release 2.07

		Updated 07/31/84


Problem:  User wants to use Shift-Fn instead of Alt-Fn key
	  combinations to access the various partitions.

Solution: Patch MultiLink as follows:
	  A>debug mlink.com
	  -e 1166 54	 (was 68)
	  -e 116b 5c	 (was 70)
	  -e 1170 5d	 (was 71)
	  -e 1176 53	 (was 67)
	  -w
	  -q


Problem:  Eagle 1600-series computer running PC-DOS locks up when
	  trying to print.

Solution: Patch MultiLink as follows:
	  A>debug mlink.com
	  -e 1f8a 74	 (was 75)
	  -w
	  -q


Problem:  RBBS-PC (bulletin board system) crashes occasionally
	  when running under MultiLink.

Comments: The following suggestions are based on information supplied
	  by Tom Mack, co-developer of RBBS, who is successfully and
	  happily running RBBS release 12.2B under MultiLink 2.07.

Solution: Avoid the use of MLSLICE. Do NOT include a terminal type
	  or baud rate with the parameters for the type-9 (RBBS)
	  partition. And finally, leave Sysop Paging off. One or
	  two of the following patches may also be applicable.


Problem:  KnowledgeMan, running in a background partition with MLVIDRAM,
	  crashes with a "memory allocation error" upon exit to DOS.

Comment:  This is a bug in KnowledgeMan; it writes beyond the 4000-byte
	  area of video RAM used for text displays.  The fix is to
	  increase the size of MLVIDRAM, which also requires patching
	  MLINK.COM.

Solution: Retrieve the file KMVIDRAM.COM and the latest MLVIDFIX.COM
	  from The Software Link's BBS at 404/451-7180.  Replace your
	  MLVIDRAM.COM with KMVIDRAM.COM.  Also, apply the following
	  patches to your MLINK.COM.  Do NOT use this version of
	  MLVIDRAM with the old MLINK, or vice versa!
	  A>debug mlink.com
	  -e edc 10	(was 0f)
	  -e ee2 10	(was 0f)
	  -e eef 10	(was 0f)
	  -e ef7 10	(was 0f)
	  -e efc 10	(was 0f)
	  -e f32 10	(was 0f)
	  -e f53 10	(was 0f)
	  -e f5c 10	(was 0f)
	  -w
	  -q


Problem:  User does not wish MultiLink to intercept printer I/O
	  requests.

Comment:  This patch is required for a PC-Net server machine.

Solution: Apply the following patch:
	  A>debug mlink.com
	  -e 3332 90 90 90 90 90 90 90 90 90 90 90 90	(12 NOP's)
	  -e 333e 90 90 90 90 90 90 90 90 90 90 90 90	(12 NOP's)
	  -w
	  -q


Problem:  FORMAT command results in "track 0 bad" error, or MLVIDFIX
	  gives strange results.

Comments: A limitation of the PC's DMA feature prevents disk I/O transfers
	  across a 64K RAM boundary. Since MultiLink permits memory
	  allocations in 1K increments, it is possible to allocate a
	  partition so that certain programs that perform block transfers
	  of disk data (such as FORMAT and VIDFIX) do not work correctly.

Solution: Perform an MLUTIL MAP function and note the starting addresses
	  for each partition, which are expressed in hexadecimal
	  segment form. Reallocate your partitions so as to avoid
	  addresses like xFxx, xExx, and xDxx; these fall just below
	  a 64K boundary and are far more likely to cause problems
	  than starting addresses like x0xx, x1xx, etc.  See Figure 1
	  in your MultiLink manual to help you decide on the new
	  allocations, and note that changing a partition's allocation
	  by 4K will change the following partition's start address
	  by hex 100.


Problem:  Users with monochrome video experience system lockup or
	  other unpredictable results when switching partitions
	  (Alt-Fn) with certain hardware/software combinations.

Solution: Apply the following patch to MLINK.COM:
	  A>debug mlink.com
	  -e 08a4 f3 a4 ba ff 03 c3
	  -e 12c9 e9 d8 f5
	  -w
	  -q


Problem:  Volkswriter screens are formatted incorrectly in background.

Solution: Apply the following patch to MLINK.COM:
	  A>debug mlink.com
	  -e 0894 89 84 94 00 26 a1 50 04 89 84 86 00 e9 43 05
	  -e 0de2 e9 af fa 90
	  -w
	  -q


Problem:  Running two or more Compiled BASIC programs which use
	  the runtime subroutines at the same time can cause a
	  system crash.

Solution: Apply the following patch to MLINK.COM:
	  A>debug mlink.com
	  -e 7f6 24	     (was 02)
	  -w
	  -q




Problem:  Running two applications which are processor-intensive
	  at the same time and at equal priority, one of them may
	  use all available processor time at the expense of the
	  other.

Solution: Retrieve a fixed version of MLSLICE.COM from The
	  Software Link's bulletin board at 404/252-9438.


Problem:  Maynard hard disk does not work with MultiLink.

Solution: Apply the following patch:
	  A>debug mlink.com
	  -e 3464 e3					 (Was C3)
	  -e 34b6 eb					 (Was 74)
	  -w
	  -q


Problem:  User does not wish MultiLink to intercept IRQ3
	  interrupts.

Solution: Apply the following patch:
	  A>debug mlink.com
	  -e e47 eb					 (Was 74)
	  -e 334a 90 90 90 90 90 90 90 90 90 90 90 90	 (12 NOP's)
	  -e 3464 ef					 (Was C3)
	  -e 34b6 eb					 (Was 74)
	  -w
	  -q


Problem:  User does not wish MultiLink to intercept IRQ4
	  interrupts.

Comments: MultiLink must be patched accordingly. The patch at 3464
	  assumes that IRQ3 *is* used by MultiLink; if you apply the
	  preceding patch also, then plug in "ff" instead of "f7"
	  at this location.

Solution: Apply the following patch:
	  A>debug mlink.com
	  -e e72 eb					 (Was 74)
	  -e 3356 90 90 90 90 90 90 90 90 90 90 90 90	 (12 NOP's)
	  -e 3464 f7					 (Was C3)
	  -e 34b6 eb					 (Was 74)
	  -w
	  -q





Problem:  User wishes shorter time slices when tasks of equal
	  priority are sharing processing time.

Comments: The default value of 1 corresponds to about 1/9 second
	  per task. Patch in 0 for 1/18 second, as shown below:

Solution: The patch is as follows:
	  A>debug mlink.com
	  -e 2473 00	   (Was 01)
	  -w
	  -q


Problem:  MultiLink's use of interrupt 7F conflicts with a user's
	  application.

Comments: Microsoft Word is the only known example of this. The
	  following patches change MultiLink to use interrupt 7D.

Solution: Several programs have to be patched. You must first get
	  the new version of MLSLICE.COM as described above. Then,
	  patch as follows:

	  A>debug mlslice.com
	  -e 0107 f6	(was FE)
	  -e 01bd f6	(was FE)
	  -e 01d5 f6	(was FE)
	  -e 01ed f6	(was FE)
	  -e 0204 7d	(was 7F)
	  -w
	  -q

	  A>debug mlink.com
	  -e 0b24 7d	(was 7F)
	  -e 0bb4 7d	(was 7F)
	  -e 2d5b f6	(was FE)
	  -e 3271 f4	(was FC)
	  -e 3278 f6	(was FE)
	  -w
	  -q

	  A>debug mlutil.com
	  -e 0104 7d	(was 7F)
	  -w
	  -q

	  A>debug mlspool.com
	  -e 025c f6	(was FE)
	  -w
	  -q

	  A>debug mlprint.com
	  -e 0104 7d	(was 7F)
	  -w
	  -q

	  A>debug mlvidram.com
	  -e 1175 f6	(was FE)
	  -w
	  -q

	  Also, locate the following statement in MLBBS:
	      MLSEG!=PEEK(&H1FE)+256*PEEK(&H1FF)
	  and change it to:
	      MLSEG!=PEEK(&H1F6)+256*PEEK(&H1F7)

04/26/84 -------------------------------------------------------------

After months of work, MultiLink release 2.07 is finally available!
The following new features are included:

PC-DOS 2.10	    PC-DOS 2.10 is now supported.

Print Spooler	    Disk files may be used as intermediate storage
		    for printed reports. Reports may be classified by
		    disposition, priority, and printing requirements.
		    Includes mainframe-style control of printing
		    operations that is far superior to any other
		    hardware or software spooler on the market.
		    NO EXTRA CHARGE!!! DOS 2.00 or 2.10 only.

Keyboard Enhancer   MLKEY command supports redefinition of
		    keys at either the console or a CRT terminal.

ANSI.SYS	    This device driver which is included with PC-DOS 2.00
		    and 2.10 is now supported.

ANSI TERMINALS	    Terminal type 8 has been added to support CRT
		    terminals that communicate with ANSI protocols.

MLUTIL.COM	    This program was added as a convenient way to run special
		    MultiLink functions at command level and can be
		    incorporated into a .BAT file.  Included is
		    a function used to send string information to
		    a serial port, and a function used to display
		    information pertaining to MultiLink memory usage,
		    ports, terminal types, baud rates and priorities.

MLTV910 	    MLTV910.COM (formerly TV910.COM) now supports
		    reverse video. Bugs have been fixed.

Performance	    MultiLink now switches between tasks more
		    frequently, giving a faster response
		    to keyboard entry.
		
Documentation	    The files README, MLBBSDOC.DOC and MLPARMS have
		    been removed from the disk, and their information
		    has been incorporated into this documentation.
		    The documentation has been completely rewritten.

Shipments will begin on Tuesday, May 1st.

01/30/84 -------------------------------------------------------------

The Revelation relational database system has been added to our list of
supported software.  See .FIXLIST.  Also, Tom Mack, a contributor to
the development of RBBS-PC, has informed us that MultiLink release 2.06
has resolved ALL OUTSTANDING PROBLEMS in the compatibility of these two
products.  An ecstatic Tom says, "You have the finest product I've ever
seen!"

01/24/84 -------------------------------------------------------------

The file MLPCTALK.DOC contains instructions for modifying PC-TALK for
more effective operation under MultiLink.

01/20/84 -------------------------------------------------------------

We have a new manager of sales and customer support: Gary Robertson,
formerly of MSA and Peachtree Software.  We expect that this will
improve the quality of our service greatly, at the same time freeing
up more time for R&D.

01/03/84 -------------------------------------------------------------

MultiLink release 2.06 is completed, and is scheduled to begin distri-
bution January 9.  This is a major release, with several important new
features.  A summary follows:

* The bulletin board (MLBBS) now supports XMODEM uploads and downloads.
  This popular file transfer method is also called Christensen protocol.

* Support for Lotus 1-2-3 at the terminals!  A breakthrough in software
  technology, the new VIDRAM and VIDFIX commands pave the way for
  support of many or most other programs that directly access video RAM.
  Type .FIXLIST for the latest list!

* Character attributes can now be used with certain terminals. The ADDS
  Viewpoint supports inverse video, and Televideo users can have
  low-intensity characters (or if the entire screen is inverse video,
  a low-intensity background for selected screen positions). This is a
  much-needed improvement for applications like WordStar and Lotus.

* Greatly improved efficiency in running popular communications soft-
  ware under MultiLink. Now you can run PC-Talk in a background par-
  tition with relatively little degradation of other tasks!

* A choice of 8 different priorities for each task!  FAST and SLOW
  commands are abolished, and a PRI command is added.

* Specialized but important features for advanced users: e.g., a "Timed
  Wait" feature, and the ability for MultiLink to abort a program and
  return to DOS if the carrier signal is lost.	Information is now
  available for checking and patching many parameters, both system-
  wide and partition-related: buffer sizes, default operation modes,
  default priorities, and many others.

11/20/83 -------------------------------------------------------------

Type ".COMMINFO" for notes regarding the use of communications packages
(such as PC-Talk or RBBS-PC) under MultiLink.

11/11/83 -------------------------------------------------------------

We have documented the modifications to Quadram's Dual Async Card for
supporting 3 or 4 serial ports on your PC; type ".DACINFO".  Also, if
you are interested in exploring MultiLink internals, type ".MLPARMS"
for a description of user-accessible parameters.

10/31/83 -------------------------------------------------------------

MultiLink release 2.05 is now available. The following improvements have
been made:

* Support for Davong's Multi-OS hard disk interface.
* Faster terminal screen handling.
*ABORTED*

27 minutes remaining.
Enter command (with leading period):

>.PATCH27

	       Patches for MultiLink release 2.07

			Updated 07/02/84



Problem:  FORMAT command results in "track 0 bad" error, or MLVIDFIX
	  gives strange results.

Comments: A limitation of the PC's DMA feature prevents disk I/O transfers
	  across a 64K RAM boundary. Since MultiLink permits memory
	  allocations in 1K increments, it is possible to allocate a
	  partition so that certain programs that perform block transfers
	  of disk data (such as FORMAT and VIDFIX) do not work correctly.

Solution: Perform an MLUTIL MAP function and note the starting addresses
	  for each partition, which are expressed in hexadecimal
	  segment form. Reallocate your partitions so as to avoid
	  addresses like xFxx, xExx, and xDxx; these fall just below
	  a 64K boundary and are far more likely to cause problems
	  than starting addresses like x0xx, x1xx, etc.  See Figure 1
	  in your MultiLink manual to help you decide on the new
	  allocations, and note that changing a partition's allocation
	  by 4K will change the following partition's start address
	  by hex 100.



Problem:  Users with monochrome video experience system lockup or
	  other unpredictable results when switching partitions
	  (Alt-Fn) with certain hardware/software combinations.

Solution: Apply the following patch to MLINK.COM:
	  A>debug mlink.com
	  -e 08a4 f3 a4 ba ff 03 c3
	  -e 12c9 e9 d8 f5
	  -w
	  -q



Problem:  Volkswriter screens are formatted incorrectly in background.

Solution: Apply the following patch to MLINK.COM:
	  A>debug mlink.com
	  -e 0894 89 84 94 00 26 a1 50 04 89 84 86 00 e9 43 05
	  -e 0de2 e9 af fa 90
	  -w
	  -q



Problem:  Running two or more Compiled BASIC programs which use
	  the runtime subroutines at the same time can cause a
	  system crash.

Solution: Apply the following patch to MLINK.COM:
	  A>debug mlink.com
	  -e 7f6 24	     (was 02)
	  -w
	  -q



Problem:  Running two applications which are processor-intensive
	  at the same time and at equal priority, one of them may
	  use all available processor time at the expense of the
	  other.

Solution: Retrieve a fixed version of MLSLICE.COM from The
	  Software Link's bulletin board at 404/252-9438.



Problem:  Maynard hard disk does not work with MultiLink.

Solution: Apply the following patch:
	  A>debug mlink.com
	  -e 3464 e3					 (Was C3)
	  -e 34b6 eb					 (Was 74)
	  -w
	  -q



Problem:  User does not wish MultiLink to intercept IRQ3
	  interrupts.

Solution: Apply the following patch:
	  A>debug mlink.com
	  -e e47 eb					 (Was 74)
	  -e 334a 90 90 90 90 90 90 90 90 90 90 90 90	 (12 NOP's)
	  -e 3464 ef					 (Was C3)
	  -e 34b6 eb					 (Was 74)
	  -w
	  -q



Problem:  User does not wish MultiLink to intercept IRQ4
	  interrupts.

Comments: MultiLink must be patched accordingly. The patch at 3464
	  assumes that IRQ3 *is* used by MultiLink; if you apply the
	  preceding patch also, then plug in "ff" instead of "f7"
	  at this location.

Solution: Apply the following patch:
	  A>debug mlink.com
	  -e e72 eb					 (Was 74)
	  -e 3356 90 90 90 90 90 90 90 90 90 90 90 90	 (12 NOP's)
	  -e 3464 f7					 (Was C3)
	  -e 34b6 eb					 (Was 74)
	  -w
	  -q



Problem:  User wishes shorter time slices when tasks of equal
	  priority are sharing processing time.

Comments: The default value of 1 corresponds to about 1/9 second
	  per task. Patch in 0 for 1/18 second, as shown below:

Solution: The patch is as follows:
	  A>debug mlink.com
	  -e 2473 00	   (Was 01)
	  -w
	  -q



Problem:  MultiLink's use of interrupt 7F conflicts with a user's
	  application.

Comments: Microsoft Word is the only known example of this. The
	  following patches change MultiLink to use interrupt 7D.

Solution: Several programs have to be patched. You must first get
	  the new version of MLSLICE.COM as described above. Then,
	  patch as follows:

	  A>debug mlslice.com
	  -e 0107 f6	(was FE)
	  -e 01bd f6	(was FE)
	  -e 01d5 f6	(was FE)
	  -e 01ed f6	(was FE)
	  -e 0204 7d	(was 7F)
	  -w
	  -q

	  A>debug mlink.com
	  -e 0b24 7d	(was 7F)
	  -e 0bb4 7d	(was 7F)
	  -e 2d5b f6	(was FE)
	  -e 3271 f4	(was FC)
	  -e 3278 f6	(was FE)
	  -w
	  -q

	  A>debug mlutil.com
	  -e 0104 7d	(was 7F)
	  -w
	  -q

	  A>debug mlspool.com
	  -e 025c f6	(was FE)
	  -w
	  -q

	  A>debug mlprint.com
	  -e 0104 7d	(was 7F)
	  -w
	  -q

	  A>debug mlvidram.com
	  -e 1175 f6	(was FE)
	  -w
	  -q

	  Also, locate the following statement in MLBBS:
	      MLSEG!=PEEK(&H1FE)+256*PEEK(&H1FF)
	  and change it to:
	      MLSEG!=PEEK(&H1F6)+256*PEEK(&H1F7)

26 minutes remaining.
Enter command (with leading period):

>
END OF TRANSFER - PRESS ENTER TO RETURN TO MENU  
&H1F7)

26 minutes remaining.
Enter command (with le